#!/bin/sh

export ORACLE_BASE=/u01/app/oracle

export ORACLE_HOME=$ORACLE_BASE/product/12.2.0/dbhome_1

export ORACLE_SID=PROD

export ORACLE_TERM=xterm

export PATH=$ORACLE_HOME/bin:/usr/sbin:$PATH:$HOME/bin

export LD_LIBRARY_PATH=$ORACLE_HOME/lib:/lib:/usr/lib

#export LANG=C

export NLS_LANG=AMERICAN_AMERICA.AL32UTF8

#以上代码为Oracle数据库运行账号oracle的系统环境变量设置，必须添加，否则crontab任务计划不能执行。

# oracle用户的系统环境变量路径：/home/oracle/.bash_profile

date=`date +%Y_%m_%d` #获取系统当前日期时间

days=90 #设置删除90天之前的备份文件

orsid=`192.168.10.19:1521/ORCL`  #Oracle数据库服务器IP、端口、SID

orowner=username #备份此用户下面的数据

bakuser=username #用此用户来执行备份，必须要有备份操作的权限

bakpass=password #执行备份的用户密码

bakdir=/backup/oracledata #备份文件路径，需要提前创建好

bakdata=$orowner"_"$date.dpdmp #备份数据库名称

baklog=$orowner"_"$date.dplog #备份执行时候生成的日志文件名称

ordatabak=$orowner"_"$date.tar.bz2 #最后保存的Oracle数据库备份文件

cd $bakdir #进入备份目录

expdp $bakuser/$bakpass DIRECTORY=expdp_bak_dir DUMPFILE=$bakdata logfile=$baklog  SCHEMAS=$bakuser VERSION=11.2.0.1.0 
tar -cvjpf $ordatabak $bakdata $baklog #压缩备份文件和日志文件

find $bakdir -type f -name "*.dplog" -exec rm {} \; #删除备份文件

find $bakdir -type f -name "*.dpdmp" -exec rm {} \; #删除日志文件

find $bakdir -type f -name "*.tar.bz2" -mtime +$days -exec rm -rf {} \; #删除90天前的备份（注意：{} \中间有空格）
